/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreProcessvarRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreProcessvar extends TableImpl<VCoreProcessvarRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_processvar</code>
     */
    public static final VCoreProcessvar V_CORE_PROCESSVAR = new VCoreProcessvar();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreProcessvarRecord> getRecordType() {
        return VCoreProcessvarRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_processvar.fk_processvar</code>.
     */
    public final TableField<VCoreProcessvarRecord, Integer> FK_PROCESSVAR = createField(DSL.name("fk_processvar"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_processvar.element_name</code>.
     */
    public final TableField<VCoreProcessvarRecord, String> ELEMENT_NAME = createField(DSL.name("element_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_processvar.processtype_name</code>.
     */
    public final TableField<VCoreProcessvarRecord, String> PROCESSTYPE_NAME = createField(DSL.name("processtype_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_processvar.referenced_name</code>.
     */
    public final TableField<VCoreProcessvarRecord, String> REFERENCED_NAME = createField(DSL.name("referenced_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_processvar.description</code>.
     */
    public final TableField<VCoreProcessvarRecord, String> DESCRIPTION = createField(DSL.name("description"), SQLDataType.CLOB, this, "");

    private VCoreProcessvar(Name alias, Table<VCoreProcessvarRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreProcessvar(Name alias, Table<VCoreProcessvarRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_processvar" as  SELECT p.pk AS fk_processvar,
         e.unique_name AS element_name,
         t.name AS processtype_name,
         r.unique_name AS referenced_name,
         ((((r.unique_name || ' is '::text) || t.name) || ' for '::text) || e.unique_name) AS description
        FROM (((common_dd.t_core_processvar p
          LEFT JOIN common_dd.t_core_processtype t ON ((t.pk = p.fk_processtype)))
          LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = p.fk_element)))
          LEFT JOIN common_dd.t_core_element_hierarchy r ON ((r.key_element = p.fk_referenced_element)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_processvar</code> table
     * reference
     */
    public VCoreProcessvar(String alias) {
        this(DSL.name(alias), V_CORE_PROCESSVAR);
    }

    /**
     * Create an aliased <code>common_dd.v_core_processvar</code> table
     * reference
     */
    public VCoreProcessvar(Name alias) {
        this(alias, V_CORE_PROCESSVAR);
    }

    /**
     * Create a <code>common_dd.v_core_processvar</code> table reference
     */
    public VCoreProcessvar() {
        this(DSL.name("v_core_processvar"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreProcessvar as(String alias) {
        return new VCoreProcessvar(DSL.name(alias), this);
    }

    @Override
    public VCoreProcessvar as(Name alias) {
        return new VCoreProcessvar(alias, this);
    }

    @Override
    public VCoreProcessvar as(Table<?> alias) {
        return new VCoreProcessvar(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreProcessvar rename(String name) {
        return new VCoreProcessvar(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreProcessvar rename(Name name) {
        return new VCoreProcessvar(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreProcessvar rename(Table<?> name) {
        return new VCoreProcessvar(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreProcessvar where(Condition condition) {
        return new VCoreProcessvar(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreProcessvar where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreProcessvar where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreProcessvar where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreProcessvar where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreProcessvar where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreProcessvar where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreProcessvar where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreProcessvar whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreProcessvar whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
